local agreetable =
{
"affirmative",
"positive",
"understood",
"got it",
"alright",
"aye",
"i'm on it",
"sure",
"fine",
"okay",
}
local localplayer = getLocalPlayer()

function getCloseSquadMembers()
	local matches = {}
	for i,v in ipairs(getElementsByType("ped")) do
		if getElementData(v,"squadleader") == localplayer then
			local px,py,pz = getElementPosition(localplayer)
			local mx,my,mz = getElementPosition(v)
			if getDistanceBetweenPoints3D(px,py,pz,mx,my,mz) <= 15 then
				table.insert(matches,v)
			end
		end
	end
	return matches
end

function makePedFollow(income)
	doForAll(income,"doMakePedFollow",", follow")
end

function makePedWait(income)
	doForAll(income,"doMakePedWait",", wait")
end

function makePedStopFire(income)
	doForAll(income,"doMakePedStopFire",", hold fire")
end

function makePedStartFire(income)
	doForAll(income,"doMakePedStartFire",", open fire")
end

function makePedMoveTo(income)
	local x,y,z = getElementPosition(getElementData(localplayer,"targetmarker"))
	if isElement(income) then
		local marker = getElementData(income,"targetmarker")
		setElementPosition(marker,x,y,z)
		setMarkerColor(marker,255,255,255,128)
		triggerServerEvent("doMakePedMoveTo",localplayer,income,x,y,z)
		triggerEvent("onMessageIncome",income,agreetable[math.random(1,#agreetable)]..", move to position",0)
	elseif type(income) == "table" then
		for i,v in ipairs(income) do
			local marker = getElementData(v,"targetmarker")
			setElementPosition(marker,x,y,z)
			setMarkerColor(marker,255,255,255,42)
			triggerEvent("onMessageIncome",v,agreetable[math.random(1,#agreetable)]..", move to position",0)
		end
		triggerServerEvent("doMakePedMoveTo",localplayer,income,x,y,z)
	end
end

function makePedGuardHere(income)
	if isElement(income) then
		local x,y,z = getElementPosition(income)
		local marker = getElementData(income,"targetmarker")
		setElementPosition(marker,x,y,z)
		setMarkerColor(marker,255,255,255,128)
		triggerServerEvent("doMakePedGuardHere",localplayer,income,x,y,z)
		triggerEvent("onMessageIncome",income,agreetable[math.random(1,#agreetable)]..", guard here",0)
	elseif type(income) == "table" then
		for i,v in ipairs(income) do
			local x,y,z = getElementPosition(v)
			local marker = getElementData(v,"targetmarker")
			setElementPosition(marker,x,y,z)
			setMarkerColor(marker,255,255,255,128)
			triggerServerEvent("doMakePedGuardHere",localplayer,v,x,y,z)
			triggerEvent("onMessageIncome",v,agreetable[math.random(1,#agreetable)]..", guard here",0)
		end
	end
end

function makePedAttack(income)
	local attackers = getCloseSquadMembers()
	for i,v in ipairs(attackers) do
		triggerServerEvent("doMakePedAttack",localplayer,v,income)
		triggerEvent("onMessageIncome",v,agreetable[math.random(1,#agreetable)]..", attack",0)
		setMarkerColor(getElementData(v,"targetmarker"),255,255,255,0)
	end
end

function makePedGuard(income)
	local x,y,z = getElementPosition(getElementData(localplayer,"targetmarker"))
	if isElement(income) then
		local marker = getElementData(income,"targetmarker")
		setElementPosition(marker,x,y,z)
		setMarkerColor(marker,255,255,255,128)
		triggerServerEvent("doMakePedGuardPosition",localplayer,income,x,y,z)
		triggerEvent("onMessageIncome",income,agreetable[math.random(1,#agreetable)]..", guard position",0)
	elseif type(income) == "table" then
		for i,v in ipairs(income) do
			local marker = getElementData(v,"targetmarker")
			setElementPosition(marker,x,y,z)
			setMarkerColor(marker,255,255,255,42)
			triggerEvent("onMessageIncome",v,agreetable[math.random(1,#agreetable)]..", guard position",0)
		end
		triggerServerEvent("doMakePedGuardPosition",localplayer,income,x,y,z)
	end
end

function doForAll(unit,event,stringaddition)
	if isElement(unit) then
		triggerServerEvent(event,localplayer,unit)
		triggerEvent("onMessageIncome",unit,agreetable[math.random(1,#agreetable)]..stringaddition,0)
		setMarkerColor(getElementData(unit,"targetmarker"),255,255,255,0)
	elseif type(unit) == "table" then
		triggerServerEvent(event,localplayer,unit)
		for i,v in ipairs(unit) do
			triggerEvent("onMessageIncome",v,agreetable[math.random(1,#agreetable)]..stringaddition,0)
			setMarkerColor(getElementData(v,"targetmarker"),255,255,255,0)
		end
	end
end