local sx,sy = guiGetScreenSize()
local targetmarker = createMarker(0,0,0,"corona",1.5,255,255,0,0)
setElementData(getLocalPlayer(),"targetmarker",targetmarker)

function getFriendlyCloseUnits()
	local matches = {}
	for i,v in ipairs(getElementsByType("ped")) do
		if getElementData(v,"squadleader") == getLocalPlayer() then
			if getElementHealth(v) > 0 then
				local pedx,pedy,pedz = getElementPosition(v)
				local playerx,playery,playerz = getElementPosition(getLocalPlayer())
				if getDistanceBetweenPoints3D(pedx,pedy,pedz,playerx,playery,playerz) <= 15 then
					table.insert(matches,v)
				end
			end
		end
	end
	if #matches >= 2 then
		table.insert(matches,"all")
	end
	return matches
end

function getFriendlyUnits()
	local matches = {}
	for i,v in ipairs(getElementsByType("ped")) do
		if getElementData(v,"squadleader") == getLocalPlayer() then
			if getElementHealth(v) > 0 then
				table.insert(matches,v)
			end
		end
	end
	if #matches >= 2 then
		table.insert(matches,"all")
	end
	return matches
end

function getEnemyCloseUnits()
	local matches = {}
	for i,v in ipairs(getElementsByType("player")) do
		if getElementHealth(v) > 0 then
			if getPlayerTeam(v) ~= getPlayerTeam(getLocalPlayer()) then
				local enemyx,enemyy,enemyz = getElementPosition(v)
				local playerx,playery,playerz = getElementPosition(getLocalPlayer())
				if getDistanceBetweenPoints3D(enemyx,enemyy,enemyz,playerx,playery,playerz) <= 45 then
					if isLineOfSightClear(enemyx,enemyy,enemyz,playerx,playery,playerz,true,false,false,true,false,true,true) then
						table.insert(matches,v)
					end
				end
			end
		end
	end
	for i,v in ipairs(getElementsByType("ped")) do
		if getElementHealth(v) > 0 then
			if getElementData(v,"pedteam") ~= getPlayerTeam(getLocalPlayer()) then
				local enemyx,enemyy,enemyz = getElementPosition(v)
				local playerx,playery,playerz = getElementPosition(getLocalPlayer())
				if getDistanceBetweenPoints3D(enemyx,enemyy,enemyz,playerx,playery,playerz) <= 45 then
					local camerax,cameray,cameraz = getCameraMatrix()
					if isLineOfSightClear(enemyx,enemyy,enemyz,camerax,cameray,cameraz,true,false,false,true,false,true,true) then
						table.insert(matches,v)
					end
				end
			end
		end
	end
	return matches
end

function getFriendlyUnitsAndMarkTarget(income)
	local matches = {}
	for i,v in ipairs(getElementsByType("ped")) do
		if getElementData(v,"squadleader") == getLocalPlayer() then
			if getElementHealth(v) > 0 then
				table.insert(matches,v)
			end
		end
	end
	if #matches >= 2 then
		table.insert(matches,"all")
	end
	
	setMarkerColor(targetmarker,255,255,0,128)
	
	return matches
end

function moveMarker()
	local r,g,b,a = getMarkerColor(targetmarker)
	if a > 0 then
		local cx,cy,cz = getCameraMatrix()
		local tx,ty,tz = getWorldFromScreenPosition(sx*0.5,sy*0.5,250)
		local hit,x,y,z,element = processLineOfSight(cx,cy,cz,tx,ty,tz,true,true,false,true,false,false,false,false,getLocalPlayer())
		if hit then
			setElementPosition(targetmarker,x,y,z)
		else
			setElementPosition(targetmarker,tx,ty,tz)
		end
	end
end
addEventHandler("onClientRender",getRootElement(),moveMarker)